diff --git a/doc/guides/nics/features.rst b/doc/guides/nics/features.rst
index edd21c4..bc978fb 100644
--- a/doc/guides/nics/features.rst
+++ b/doc/guides/nics/features.rst
@@ -913,6 +913,20 @@ Supports to get Rx/Tx packet burst mode information.
 * **[implements] eth_dev_ops**: ``rx_burst_mode_get``, ``tx_burst_mode_get``.
 * **[related] API**: ``rte_eth_rx_burst_mode_get()``, ``rte_eth_tx_burst_mode_get()``.
 
+.. _nic_features_traffic_manager_packet_marking_offload:
+
+Traffic Manager Packet marking offload
+--------------------------------------
+
+Supports enabling a packet marking offload specific mbuf.
+
+* **[uses]     mbuf**: ``mbuf.ol_flags:PKT_TX_MARK_IP_DSCP``,
+  ``mbuf.ol_flags:PKT_TX_MARK_IP_ECN``, ``mbuf.ol_flags:PKT_TX_MARK_VLAN_DEI``,
+  ``mbuf.ol_flags:PKT_TX_IPV4``, ``mbuf.ol_flags:PKT_TX_IPV6``.
+* **[uses]     mbuf**: ``mbuf.l2_len``.
+* **[related] API**: ``rte_tm_mark_ip_dscp()``, ``rte_tm_mark_ip_ecn()``,
+  ``rte_tm_mark_vlan_dei()``.
+
 .. _nic_features_other:
 
 Other dev ops not represented by a Feature
diff --git a/lib/librte_mbuf/rte_mbuf.c b/lib/librte_mbuf/rte_mbuf.c
index cd5794d..5c6896d 100644
--- a/lib/librte_mbuf/rte_mbuf.c
+++ b/lib/librte_mbuf/rte_mbuf.c
@@ -880,6 +880,9 @@ const char *rte_get_tx_ol_flag_name(uint64_t mask)
 	case PKT_TX_SEC_OFFLOAD: return "PKT_TX_SEC_OFFLOAD";
 	case PKT_TX_UDP_SEG: return "PKT_TX_UDP_SEG";
 	case PKT_TX_OUTER_UDP_CKSUM: return "PKT_TX_OUTER_UDP_CKSUM";
+	case PKT_TX_MARK_VLAN_DEI: return "PKT_TX_MARK_VLAN_DEI";
+	case PKT_TX_MARK_IP_DSCP: return "PKT_TX_MARK_IP_DSCP";
+	case PKT_TX_MARK_IP_ECN: return "PKT_TX_MARK_IP_ECN";
 	default: return NULL;
 	}
 }
@@ -916,6 +919,9 @@ rte_get_tx_ol_flag_list(uint64_t mask, char *buf, size_t buflen)
 		{ PKT_TX_SEC_OFFLOAD, PKT_TX_SEC_OFFLOAD, NULL },
 		{ PKT_TX_UDP_SEG, PKT_TX_UDP_SEG, NULL },
 		{ PKT_TX_OUTER_UDP_CKSUM, PKT_TX_OUTER_UDP_CKSUM, NULL },
+		{ PKT_TX_MARK_VLAN_DEI, PKT_TX_MARK_VLAN_DEI, NULL },
+		{ PKT_TX_MARK_IP_DSCP, PKT_TX_MARK_IP_DSCP, NULL },
+		{ PKT_TX_MARK_IP_ECN, PKT_TX_MARK_IP_ECN, NULL },
 	};
 	const char *name;
 	unsigned int i;
diff --git a/lib/librte_mbuf/rte_mbuf_core.h b/lib/librte_mbuf/rte_mbuf_core.h
index b9a59c8..d9f1290 100644
--- a/lib/librte_mbuf/rte_mbuf_core.h
+++ b/lib/librte_mbuf/rte_mbuf_core.h
@@ -187,11 +187,40 @@ extern "C" {
 /* add new RX flags here, don't forget to update PKT_FIRST_FREE */
 
 #define PKT_FIRST_FREE (1ULL << 23)
-#define PKT_LAST_FREE (1ULL << 40)
+#define PKT_LAST_FREE (1ULL << 37)
 
 /* add new TX flags here, don't forget to update PKT_LAST_FREE  */
 
 /**
+ * Packet marking offload flags. These flags indicated what kind
+ * of packet marking needs to be applied on a given mbuf when
+ * appropriate Traffic Manager configuration is in place.
+ * When user set's these flags on a mbuf, below assumptions are made
+ * 1) When PKT_TX_MARK_VLAN_DEI is set,
+ * a) PMD assumes pkt to be a 802.1q packet.
+ * b) Application should also set mbuf.l2_len where 802.1Q header is
+ *    at (mbuf.l2_len - 6) offset.
+ * 2) When PKT_TX_MARK_IP_DSCP is set,
+ * a) Application should also set either PKT_TX_IPV4 or PKT_TX_IPV6
+ *    to indicate whether if it is IPv4 packet or IPv6 packet
+ *    for DSCP marking. It should also set PKT_TX_IP_CKSUM if it is
+ *    IPv4 pkt.
+ * b) Application should also set mbuf.l2_len that indicates
+ *    start offset of L3 header.
+ * 3) When PKT_TX_MARK_IP_ECN is set,
+ * a) Application should also set either PKT_TX_IPV4 or PKT_TX_IPV6.
+ *    It should also set PKT_TX_IP_CKSUM if it is IPv4 pkt.
+ * b) PMD will assume pkt L4 protocol is either TCP or SCTP and
+ *    ECN is set to 2'b01 or 2'b10 as per RFC 3168 and hence HW
+ *    can mark the packet for a configured color.
+ * c) Application should also set mbuf.l2_len that indicates
+ *    start offset of L3 header.
+ */
+#define PKT_TX_MARK_VLAN_DEI		(1ULL << 38)
+#define PKT_TX_MARK_IP_DSCP		(1ULL << 39)
+#define PKT_TX_MARK_IP_ECN		(1ULL << 40)
+
+/**
  * Outer UDP checksum offload flag. This flag is used for enabling
  * outer UDP checksum in PMD. To use outer UDP checksum, the user needs to
  * 1) Enable the following in mbuf,
@@ -384,7 +413,10 @@ extern "C" {
 		PKT_TX_MACSEC |		 \
 		PKT_TX_SEC_OFFLOAD |	 \
 		PKT_TX_UDP_SEG |	 \
-		PKT_TX_OUTER_UDP_CKSUM)
+		PKT_TX_OUTER_UDP_CKSUM | \
+		PKT_TX_MARK_VLAN_DEI |	 \
+		PKT_TX_MARK_IP_DSCP |	 \
+		PKT_TX_MARK_IP_ECN)
 
 /**
  * Mbuf having an external buffer attached. shinfo in mbuf must be filled.